// Autocode by Denis L. Seleznev / Hidden Codes 2k4, mailto:hcodes@narod.ru

#define CATCOMP_BLOCK
#define CATCOMP_NUMBERS
#define CATCOMP_STRINGS

#include "Autocode.h"
#include "locale/locale_en.h"
#include "conv.cpp"

#define AC_VERSION              "1.4"
#define AC_NAME                 "Autocode"
#define AC_VER_STR              AC_NAME" "AC_VERSION
#define AC_BUILD_TIME           __DATE__ " " __TIME__
#define AC_VERSION_FULL         AC_VER_STR "\n" AC_BUILD_TIME

#define ERROR_BEGIN				"\x9b\x37;31;40m"
#define ERROR_END				":\x9b\x30;31;40m "

#define PARAM "file/A,to/K,suf/K,inmap/K,outmap/K,mapfile/K,pack/S,xpkpas=xpkpassword/K,xpkmet=xpkmethod/K,viewtool/K,nohtml/S,notabs/S,nospaces/S,noends/S,tm=textmode/S,nocomment/S,norus/S,noss/S,debug/S"

struct {
	STRPTR file;
	STRPTR to;
	STRPTR suf;
	STRPTR inmap;
	STRPTR outmap;
	STRPTR mapfile;
	ULONG  *pack;
	STRPTR xpkpas;
	STRPTR xpkmet;
	STRPTR viewtool;
	ULONG  *nohtml;
	ULONG  *notabs;
	ULONG  *nospaces;
	ULONG  *noends;
	ULONG  *textmode;
	ULONG  *nocomment;
	ULONG  *norus;
	ULONG  *noss;
	ULONG  *debug;
	} args;

struct Library *XpkBase=NULL, *AslBase=NULL, *MUIMasterBase=NULL;
struct DiskObject *sdo=NULL;
struct RDArgs   *srda=NULL;
struct Catalog *CatalogBase=NULL;
struct FileInfoBlock     *sfib = NULL;
struct WBStartup *argmsg;
struct WBArg *wb_arg;

BOOL fXpk=FALSE;
BOOL fPack=FALSE;
BOOL fViewText=FALSE;
BOOL fDebug=FALSE;
BOOL fWB=FALSE;
BOOL fTempFile=FALSE;
BOOL fNoSelectMap=FALSE;
BOOL fNoHtml=FALSE;
BOOL fNoTabs=FALSE;
BOOL fNoSpaces=FALSE;
BOOL fNoEnds=FALSE;
BOOL fNoRus=FALSE;
BOOL fNoSS=FALSE;
BOOL fRus=FALSE;
BOOL fTextMode=FALSE;
BOOL fMUI=FALSE;
BOOL fNoComment=FALSE;
BOOL fAlwaysSelectMap=FALSE;

STRPTR  pOBuf=NULL;
STRPTR  pIBuf=NULL;
ULONG   ulIBuflen=0, ulIlen=0, ulMainSize=0;
ULONG   ulOBuflen=0, ulOlen=0;

long lErr;

struct FileRequester *psReq=NULL;
FILE *hInFile=NULL, * hOutFile=NULL, *hPrefsFile=NULL;

char szCli[3*MAX_PATH]={0};
char szErrBuf[3*MAX_PATH]={0};
char szName[MAX_PATH]={0};
char szPath[MAX_PATH]={0};
char szNamep[MAX_PATH]={0};
char szTo[MAX_PATH]={0};
char szDob[MAX_PATH]={0};
char szMapFile[MAX_PATH]={0};
char szViewer[MAX_PATH]={0};

char szSufix[BUF_LEN]={0};
char szInMap[BUF_LEN]={0};
char szOutMap[BUF_LEN]=CC_1251;
char szXPKMethod[BUF_LEN]={0};
char szMyXPKMethod[BUF_LEN]={0};
char szXPKPassword[BUF_LEN]={0};

char* cMain=NULL;

char g_szVersion[]="$VER: " AC_VERSION_FULL;

void Report(STRPTR text);
void BeforeExit(void);
BOOL IsXpk(unsigned char *ucText, int iLen, char* cMethod);
void CliParams(int argc, char *argv[]);
void WBParams(void);
unsigned long NoHtml(unsigned char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf);
unsigned long NoTabs(unsigned char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf);
unsigned long NoSpaces(unsigned char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf);
unsigned long NoEnds(unsigned char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf);
unsigned long TextMode(unsigned char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf);
unsigned long NoRus(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf);
unsigned long NoSS(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf);
BOOL SelectMap(char* szIn);
BOOL NoWorkInUTF(void);


extern unsigned long ConvertWithConstMap(char* , char* , unsigned char* , unsigned long  , unsigned char* , char*);
extern BOOL ConvertWithMapFile(char* , unsigned char* , unsigned long , unsigned char* , char* );
extern BOOL DefineMap(unsigned char* , unsigned long , char*);
extern BOOL IsSupportMap(char* );
extern unsigned long CalcBufMap(char* , unsigned char* , unsigned long);
//---------------------------------------------------------------------------
STRPTR GetString(LONG stringNum)
{
LONG   *l;
UWORD  *w;
STRPTR  builtIn;

    l = (LONG *)CatCompBlock;

    while (*l != stringNum)
    {
        w = (UWORD *)((ULONG)l + 4);
        l = (LONG *)((ULONG)l + (ULONG)*w + 6);
    }
    builtIn = (STRPTR)((ULONG)l + 6);

    return(GetCatalogStr(CatalogBase,stringNum,builtIn));
}
//---------------------------------------------------------------------------
void Init_MUI_Cat()
{
	if (!MUIMasterBase)
	{
		MUIMasterBase = OpenLibrary((unsigned char*) MUIMASTER_NAME, (unsigned long) MUIMASTER_VMIN);
	}
	if (!CatalogBase)
	{
		CatalogBase=OpenCatalog(NULL, AC_NAME ".catalog", TAG_DONE);
	}

	return;
}
//---------------------------------------------------------------------------
BOOL NoWorkInUTF(void)
{
	static BOOL fStart=FALSE;

	if (!stricmp(szOutMap, CC_UTF16) || !stricmp(szOutMap, CC_UTF32) || !stricmp(szOutMap, CC_UNICODE) || !stricmp(szOutMap, CC_UTF7))
	{
		if (!fStart)     Report("arguments:\n'nohtml', \n'notabs', \n'nospaces, \n'noends', \n'noss', \n'textmode' \n'norus'\nwith outmap='UNICODE', 'UTF16', 'UTF32', 'UTF7' \nno work in this version !\n ");
		fStart=TRUE;
		return TRUE;
	}

	return FALSE;
}
//---------------------------------------------------------------------------
BOOL SelectMap(char* szIn)
{
	int i;
	struct EasyStruct est;
	est.es_StructSize = sizeof(struct EasyStruct);
	est.es_Flags = 0;
	est.es_Title = (unsigned char*) GetString(MSG_ERROR);
	if (fAlwaysSelectMap)	est.es_Title = (unsigned char*) GetString(MSG_REQUEST);

	est.es_TextFormat = (unsigned char*) GetString(MSG_CHOOSE_MAP);
	if (fAlwaysSelectMap)	est.es_TextFormat = (unsigned char*) GetString(MSG_SELECT_MAP);

	est.es_GadgetFormat =(unsigned char*) szErrBuf;
	*szErrBuf=0;

	for (i=0; i<MAPS_FOR_MESSAGEBOX_N; i++)
	{
		//strcat(szErrBuf, "_");
		strcat(szErrBuf, pMaps[i]);
		strcat(szErrBuf, "|");
	}
	i++;

	//strcat(szErrBuf, "_");
	strcat(szErrBuf, GetString(MSG_CANCEL));

	DisplayBeep(NULL);

	int k;
	if (MUIMasterBase)
    {
		k=(int) MUI_Request((unsigned long) NULL, (unsigned long) NULL, 0,(char*)  est.es_Title, (char*) est.es_GadgetFormat, (char*)est.es_TextFormat);
	}
	else
	{
		k=(int) EasyRequestArgs(NULL, &est, NULL, NULL);
	}

	if (!k || k<0)  return FALSE;

	strcpy(szIn, pMaps[k-1]);

	*szErrBuf=0;

	return TRUE;
}
//---------------------------------------------------------------------------
unsigned long NoHtml(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf)
{
	unsigned long i, k=0;
	int l=0;
	BOOL fStop=FALSE;
	for (i=0; i<ulLen && k<ulLenBuf; i++)
	{
		if (ucText[i]=='<')
		{
			fStop=TRUE;
			l++;
		}
		if (!fStop)
		{
			ucTextBuf[k++]=ucText[i];
		}
		if (ucText[i]=='>' && fStop)
		{
			if (l>0)	l--;
			if (!l) fStop=FALSE;
		}
	}
	return k;
}
//---------------------------------------------------------------------------
unsigned long NoTabs(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf)
{
	unsigned long i, k=0;
	for (i=0; i<ulLen && k<ulLenBuf; i++)
	{
		if (ucText[i]!=9)
		{
			ucTextBuf[k++]=ucText[i];
		}
	}
	return k;
}
//---------------------------------------------------------------------------
unsigned long NoSpaces(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf)
{
		unsigned long i, k=0;
		BOOL fSpace=FALSE;
		for (i=0; i<ulLen && k<ulLenBuf; i++)
		{
			if  (fSpace && ucText[i]==' ')
			{
				while(i<ulLen && ucText[i]==' ')
				{
					i++;
				}
				fSpace=FALSE;
			}

			ucTextBuf[k++]=ucText[i];

			if (ucText[i]==' ' && !fSpace)
			{
				fSpace=TRUE;
			}
			else
			{
				fSpace=FALSE;
			}
		}

	return k;
}
//---------------------------------------------------------------------------
unsigned long NoRus(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf)
{
	unsigned long i, k=0;
	for (i=0; i<ulLen && k<ulLenBuf; i++)
	{
		if (ucText[i]>=0)
		{
			ucTextBuf[k++]=ucText[i];
		}
	}

return k;
}
//---------------------------------------------------------------------------
unsigned long NoSS(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf)
{
	unsigned long i, k=0;
	for (i=0; i<ulLen && k<ulLenBuf; i++)
	{
		if (ucText[i]>=0 && ucText[i]!=10 && ucText[i]!=9 && ucText[i]!=13 && ucText[i]<=31)
		{

		}
		else
		{
			ucTextBuf[k++]=ucText[i];
		}
	}

	return k;
}
//---------------------------------------------------------------------------
unsigned long NoEnds(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf)
{
	unsigned long i, k=0, n;
	BOOL f10=TRUE;

	for (i=0; i<ulLen && k<ulLenBuf; i++)
	{

		if  (f10)
		{
			n=i;
			while(n<ulLen && (ucText[n]==' ' || ucText[n]==13 || ucText[n]==9 || ucText[n]==10))
			{
				if (ucText[n++]==10)	i=n;

				if (i>=(ulLen-1))	i=ulLen-1;
			}
			f10=FALSE;
		}
		if (ucText[i]==10)	f10=TRUE;

		ucTextBuf[k++]=ucText[i];
	}

	return k;
}
//---------------------------------------------------------------------------
unsigned long TextMode(char* ucText, unsigned long ulLen, char* ucTextBuf, unsigned long ulLenBuf)
{
	unsigned long i, k=0;
	for (i=0; i<ulLen && k<ulLenBuf; i++)
	{
		if (ucText[i]!=13)
		{
			ucTextBuf[k++]=ucText[i];
		}
	}

return k;
}
//---------------------------------------------------------------------------
void Report(STRPTR text)
{
        if (fWB)
        {
          struct EasyStruct est;
          est.es_StructSize = sizeof(struct EasyStruct);
          est.es_Flags = 0;
          est.es_Title = (unsigned char*) (AC_NAME ", ");
          strcat((char*) est.es_Title, GetString(MSG_ERROR));
          est.es_TextFormat = (unsigned char*) text;
          est.es_GadgetFormat =(unsigned char*) "Ok";

          DisplayBeep(NULL);
          if (MUIMasterBase)
          {
                MUI_Request((unsigned long) NULL, (unsigned long)NULL, 0, (char*) est.es_Title, (char*) est.es_GadgetFormat, (char*) est.es_TextFormat);
          }
          else
          {
               EasyRequestArgs(NULL, &est, NULL, NULL);
          }
        }
        else
        {
                printf(ERROR_BEGIN AC_NAME ", ");
				printf(GetString(MSG_ERROR));
				printf(ERROR_END);
                printf(text);
        }

        return;
}
//----------------------------------------------------------------------------
void SetMyComment()
{
	if (!fNoComment && !fWB)
	{
		BPTR hMyFile=Open(szName, MODE_OLDFILE);
		if ((sfib = (struct FileInfoBlock *) AllocDosObject(DOS_FIB, 0)) && ExamineFH(hMyFile, sfib))
		{
			SetComment(szDob, sfib->fib_Comment);
		}
		if (hMyFile)	Close(hMyFile);
		if (sfib)     FreeDosObject(DOS_FIB, sfib);
	}
}
//----------------------------------------------------------------------------
void BeforeExit(void)
{
        if (XpkBase)
        {
                CloseLibrary(XpkBase);
                XpkBase=NULL;
        }

        if (pOBuf)      FreeMem(pOBuf, ulOBuflen);
        if (pIBuf)      FreeMem(pIBuf, ulIBuflen);

        if (hInFile)    fclose(hInFile);
        if (hOutFile)   fclose(hOutFile);

        if (sdo)        FreeDiskObject(sdo);
        if(srda)        FreeArgs(srda);

        if(CatalogBase)        CloseCatalog(CatalogBase);
        if (MUIMasterBase)     CloseLibrary(MUIMasterBase);

        if (fTempFile)  remove("t:" AC_NAME ".txt");
}

//---------------------------------------------------------------------------
BOOL IsXpk(unsigned char *ucText, int iLen, char* cMethod)
{
	BOOL iXpk=FALSE;
	if (!strncmp((char*) "XPK", (char*) ucText, (unsigned int) 3) && iLen>12)
	{
		iXpk=TRUE;
		memcpy(cMethod, &ucText[8], 4);
		cMethod[4]=0;
	}
	else
	{
		iXpk=FALSE;
		*cMethod=0;
	}

	return iXpk;
}
//---------------------------------------------------------------------------
void CliParams(int argc, char *argv[])
{
	memset(&args, 0, sizeof(args));

	if (srda = ReadArgs(PARAM, (LONG *) &args, NULL))
	{
		if (args.file)		strncpy(szName, args.file, MAX_PATH-1);
		if (args.to)		strncpy(szTo, args.to, MAX_PATH-1);
		if (args.suf)		strncpy(szSufix, args.suf, BUF_LEN-1);
		if (args.inmap)		strncpy(szInMap, args.inmap, BUF_LEN-1);
		if (args.outmap)	strncpy(szOutMap, args.outmap, BUF_LEN-1);
		if (args.mapfile)	strncpy(szMapFile, args.mapfile, BUF_LEN-1);
		if (args.pack)		fPack=TRUE;
		if (args.xpkpas)	strncpy(szXPKPassword, args.xpkpas, BUF_LEN-1);
		if (args.xpkmet)	strncpy(szMyXPKMethod, args.xpkmet, BUF_LEN-1);
		if (args.viewtool)
		{
			strncpy(szViewer, args.viewtool, MAX_PATH-1);
			fViewText=TRUE;
		}
		if (args.nohtml)	fNoHtml=TRUE;
		if (args.notabs)	fNoTabs=TRUE;
		if (args.nospaces)	fNoSpaces=TRUE;
		if (args.noends)	fNoEnds=TRUE;
		if (args.textmode)	fTextMode=TRUE;
		if (args.nocomment)	fNoComment=TRUE;
		if (args.norus)		fNoRus=TRUE;
		if (args.noss)		fNoSS=TRUE;
		if (args.debug)		fDebug=TRUE;
	}
	else
	{
		Fault(IoErr(), AC_NAME, szErrBuf, 3*MAX_PATH);
		strcat(szErrBuf,"\n");
		Report(szErrBuf);
		BeforeExit();
		exit(RETURN_FAIL);
	}

	return;
}
//---------------------------------------------------------------------------
void WBParams(void)
{
	char* szBuf=NULL;
	*szViewer=0;
	fViewText=FALSE;

	if ((sdo=GetDiskObject((unsigned char*) AC_NAME)))
	{
		szBuf=(char*) FindToolType((unsigned char**) sdo->do_ToolTypes, (unsigned char*) "viewtool");
		if (szBuf && *szBuf)
		{
			strncpy(szViewer, szBuf, MAX_PATH-1);
			fViewText=TRUE;
		}
		szBuf=(char*) FindToolType((unsigned char**) sdo->do_ToolTypes, (unsigned char*) "outmap");
		if (szBuf)
		{
			strncpy(szOutMap, szBuf, BUF_LEN-1);
		}

		szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "xpkpassword");
		if (szBuf)
		{
			strncpy(szXPKPassword, szBuf, BUF_LEN-1);
		}
		szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "debug");
		if (szBuf)
		{
			fDebug=TRUE;
		}
		szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "nohtml");
		if (szBuf)
		{
			fNoHtml=TRUE;
		}
		szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "notabs");
		if (szBuf)
		{
			fNoTabs=TRUE;
		}
		szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "nospaces");
		if (szBuf)
		{
			fNoSpaces=TRUE;
		}

                szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "noselectmap");
                if (szBuf)
                {
                        fNoSelectMap=TRUE;
                }
                szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "noends");
                if (szBuf)
                {
                        fNoEnds=TRUE;
                }
                szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "textmode");
                if (szBuf)
                {
                        fTextMode=TRUE;
                }
                szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "alwaysselectmap");
                if (szBuf)
                {
					fAlwaysSelectMap=TRUE;
                }
                  szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "norus");
                if (szBuf)
                {
					fNoRus=TRUE;
                }
                  szBuf=(char*) FindToolType((unsigned char**)sdo->do_ToolTypes, (unsigned char*) "noss");
                if (szBuf)
                {
					fNoSS=TRUE;
                }

        }
        if (argmsg->sm_NumArgs>1)
        {
				if ((wb_arg+1)->wa_Lock && NameFromLock((wb_arg+1)->wa_Lock, szName, MAX_PATH))
				{

					if (*((char*)((wb_arg+1)->wa_Name)))
					{
						AddPart(szName, (STRPTR)((wb_arg+1)->wa_Name), MAX_PATH);
					}
				}

		}
		if (*szName)	return;

        if (AslBase = OpenLibrary((unsigned char*) AslName, 39))
        {
                hPrefsFile=fopen("ENVARC:" AC_NAME ".prefs", "r");
                memset(szDob, 0, MAX_PATH);

                if (hPrefsFile)
                {
                        fread((void*) szDob, 1, MAX_PATH, hPrefsFile);
                        fclose(hPrefsFile);
                }

                if (psReq = (FileRequester*) AllocAslRequestTags(ASL_FileRequest, ASLFR_InitialDrawer, szDob, ASLFR_TitleText, GetString(MSG_SELECT_TEXT_FILE), TAG_DONE, NULL))
                {
                        if (AslRequest(psReq, NULL))
                        {
                           strcpy(szName, psReq->fr_Drawer);
                           hPrefsFile=fopen("ENVARC:" AC_NAME ".prefs", "w");
                           if (hPrefsFile)
                           {
                                fwrite((void*) szName, strlen(szName)+1, 1, hPrefsFile);
                                fclose(hPrefsFile);
                           }

                                /*unsigned int i=0;
                                i=strlen(szName);
                                if (i && szName[i-1]!=':')
                                {
                                        szName[i]='/';
                                        szName[i+1]=0;
                                }
                                strcat(szName, psReq->fr_File);*/
							AddPart(szName, psReq->fr_File, MAX_PATH);
                        }
                        else
                        {
                                if (IoErr())
                                {
                                        Report(GetString(MSG_NOREQ));
                                }
                                else
                                {
                                        *szName=0;
                                        BeforeExit();
                                        exit(RETURN_FAIL);
                                }
                        }

                        FreeAslRequest(psReq);
                }
                else
                {
                        Report(GetString(MSG_NOCREATE_REQ));
                        BeforeExit();
                        exit(RETURN_FAIL);
                }

                CloseLibrary(AslBase);
        }
        else
        {
                Report(GetString(MSG_NOOPEN_ASL));
                BeforeExit();
                exit(RETURN_FAIL);
        }
        return;
}

//---------------------------------------------------------------------------
int main(int argc, char *argv[])
{
		Init_MUI_Cat();
        if (argc)      CliParams(argc, argv);  //     Cli
        else
        {
                fWB=TRUE;
				argmsg = (struct WBStartup *)argv ;
				wb_arg = argmsg->sm_ArgList ;
                WBParams();                             //     ToolTypes
        }
        if (!fViewText && fWB)
        {
                Report(GetString(MSG_NOFIND_VIEWTOOL));
                BeforeExit();
                exit(RETURN_FAIL);
        }

        int i;
        if (*szInMap && !IsSupportMap(szInMap))
        {
			sprintf(szErrBuf, "inmap=%s - ", szInMap);
			strcpy(szErrBuf+strlen(szErrBuf),GetString(MSG_NOSUPPORT_MAP));
                for (i=0; i<MAPS_N; i++)
                {
                        strcat(szErrBuf, pMaps[i]);
                        if (i==MAPS_N-1)        strcat(szErrBuf, ".\n");
                        else    strcat(szErrBuf, ", ");

                }
                Report(szErrBuf);
                BeforeExit();
                exit(RETURN_FAIL);
        }
        if (*szOutMap && !IsSupportMap(szOutMap))
        {
		sprintf(szErrBuf, "outmap=%s - ", szOutMap);
		strcpy(szErrBuf+strlen(szErrBuf), GetString(MSG_NOSUPPORT_MAP));
                for (i=0; i<MAPS_N; i++)
                {
                        strcat(szErrBuf, pMaps[i]);
                        if (i==MAPS_N-1)        strcat(szErrBuf, ".\n");
                        else    strcat(szErrBuf, ", ");

                }

                Report(szErrBuf);
                BeforeExit();
                exit(RETURN_FAIL);
        }

        if (!*szViewer && !*szTo && !*szSufix)
        {
                Report(GetString(MSG_NONAME_OUTFILE));
                BeforeExit();
                exit(RETURN_FAIL);
        }

        i=PathPart(szName)-szName;
        memcpy(szPath, szName, i);      //   
        szPath[i]=0;

        if (i && szPath[i-1]!=':' && szPath[i-1]!='/')
        {
                szPath[i]='/';
                szPath[i+1]=0;
		}
        strncat(szNamep, &szName[i], strlen(szName)-i); //    

        char* pcPoint=NULL;
        for (i=(int) (strlen(szNamep)-1); i>=0; i--)
        {
                if (szNamep[i]=='.')
                {
                        if (!stricmp(&szNamep[i], ".html") || !stricmp(&szNamep[i], ".htm"))
                        {
                                pcPoint=&szNamep[i];
                        }
                        if (!stricmp(&szNamep[i], ".shtml") || !stricmp(&szNamep[i], ".shtm"))
                        {
                                pcPoint=&szNamep[i];
                        }
                        if (!stricmp(&szNamep[i], ".phtml") || !stricmp(&szNamep[i], ".phtm"))
                        {
                                pcPoint=&szNamep[i];
                        }

                }
        }
        if (*szTo)
        {
                unsigned int iDir;
                iDir=strlen(szTo)-(PathPart(szTo)-szTo);

                if (fDebug)
                {
                        sprintf(szErrBuf, "iDir=%d\n", iDir);
                        Report(szErrBuf);
                }

                if (iDir)
                {
                        *szPath=0;
                        *szNamep=0;
                }
                else
                {
                        *szPath=0;
                }
        }

        if (*szViewer && !*szTo && !*szSufix)
        {
                strcpy(szDob, "t:" AC_NAME ".txt");
                fTempFile=TRUE;
        }
        else
        {
                sprintf(szDob, "%s%s%s%s", szTo, szPath, szNamep, szSufix);
        }

        if (!stricmp(szInMap, "KOI8"))  strcpy(szInMap, CC_KOI8R);
        if (!stricmp(szOutMap, "KOI8")) strcpy(szOutMap, CC_KOI8R);

        hInFile=fopen(szName, "r");
        if (!hInFile)
        {
		   strcpy(szErrBuf, GetString(MSG_NOOPEN_INFILE));
	       sprintf(szErrBuf+strlen(szErrBuf), " - %s !\n", szName);
                Report(szErrBuf);
                BeforeExit();
                exit(RETURN_FAIL);
        }

        fseek(hInFile, 0, SEEK_END);
        ulIBuflen=ftell(hInFile)+1;

        fseek(hInFile, 0, SEEK_SET);

        pIBuf=(STRPTR) AllocMem(ulIBuflen, MEMF_ANY|MEMF_CLEAR);

        cMain=pIBuf;

        if (!cMain)
        {
                Report(GetString(MSG_OUT_MEMORY));
                BeforeExit();
                exit(RETURN_FAIL);
        }

        ulMainSize=ulIlen=ulIBuflen-1;
        cMain[ulMainSize]=0;

        fread((void*) cMain, 1, ulMainSize, hInFile);

//-----Unpack XPK------
        if (IsXpk((unsigned char*) cMain, ulMainSize, (char*)szXPKMethod))
        {
                XpkBase=OpenLibrary((unsigned char*) XPKNAME, (unsigned long) 0);

                if (!XpkBase)
                {
				strcpy(szErrBuf, GetString(MSG_NOOPEN));
                        strcat(szErrBuf, " " XPKNAME "\n");
				Report(szErrBuf);
                        BeforeExit();
                        exit(RETURN_FAIL);
                }

                if  (XpkUnpackTags(XPK_InBuf, pIBuf, XPK_InLen, ulIBuflen,
                        XPK_GetOutBuf, &pOBuf, XPK_GetOutBufLen, &ulOBuflen,
                        XPK_GetOutLen, &ulOlen, XPK_GetError, szErrBuf,  XPK_Password, szXPKPassword, TAG_DONE))
        //    XPK_PassThru, 1, XPK_ChunkHook, &chunkhook, TAG_DONE))
                {
                        strcat(szErrBuf, "\n");
                        Report(szErrBuf);
                        BeforeExit();
                        exit(RETURN_FAIL);
                }
                fXpk=TRUE;
                if (!fPack)     fXpk=FALSE;
                else if (!*szMyXPKMethod)
                {
                        strncpy(szMyXPKMethod, szXPKMethod, 4);
                        szMyXPKMethod[4]=0;
                }

        FreeMem(pIBuf, ulIBuflen);

        cMain=pIBuf=pOBuf;

        ulIBuflen=ulOBuflen;
        ulMainSize=ulIlen=ulOlen;

        pOBuf=NULL;
        ulOBuflen=ulOlen=0;
        }

//-----end of Unpack XPK------

        if (*szMapFile)
        {

                if (!ConvertWithMapFile((char*) szMapFile, (unsigned char*) cMain, ulMainSize, (unsigned char*) cMain, ulMainSize, szErrBuf))
                {
                        Report(szErrBuf);
                        BeforeExit();
                        exit(RETURN_FAIL);
                }

        }
        else
        {
                if (!*szInMap)
                {
						if (fAlwaysSelectMap && fWB)
						{
							if (!SelectMap(szInMap))
                         	{
	                            BeforeExit();
	                            exit(RETURN_FAIL);
							}

						}
                        else if (!DefineMap((unsigned char*) cMain, ulMainSize, szInMap))
                        {
                                if (!fNoSelectMap && fWB)
                                {
                                        if (!SelectMap(szInMap))
                                        {
                                                BeforeExit();
                                                exit(RETURN_FAIL);
                                        }
                                }
                                else
                                {
                                        Report(GetString(MSG_NODEFINE_MAP));
                                        BeforeExit();
                                        exit(RETURN_FAIL);
                                }
                        }
                }

                unsigned long k=CalcBufMap(szInMap, szOutMap, (unsigned char*) cMain, ulMainSize);
                if (fDebug) printf("k=%d\n", k);
                if (!k)
                {
                        Report(GetString(MSG_UNKNOW_ERROR));
                        BeforeExit();
                      exit(RETURN_FAIL);
                }
                else
                {
                        pOBuf=(STRPTR) AllocMem(k, MEMF_ANY|MEMF_CLEAR);
                        if (!pOBuf)
                        {
                                Report(GetString(MSG_OUT_MEMORY));
                                BeforeExit();
                              exit(RETURN_FAIL);
                        }
                        ulOBuflen=ulOlen=k;
                }

                if (!(ulOlen=ConvertWithConstMap((char*) szInMap, (char*) szOutMap, (unsigned char*) cMain, ulMainSize, (unsigned char*) pOBuf, ulOBuflen, szErrBuf)))
                {
                        Report(szErrBuf);
                        BeforeExit();
                      exit(RETURN_FAIL);
                }
                else
                {
                    if (fDebug)     printf("ulOlen=%d\n", ulOlen);
                        FreeMem(pIBuf, ulIBuflen);

                        cMain=pIBuf=pOBuf;

                        ulIBuflen=ulOBuflen;
                        ulMainSize=ulIlen=ulOlen;

                        pOBuf=NULL;
                        ulOBuflen=ulOlen=0;
                }

        }

        if (fNoHtml && pcPoint)
        {
               if (!NoWorkInUTF())
               {
                ulIlen=NoHtml(cMain, ulMainSize, cMain, ulMainSize);
                ulMainSize=ulIlen;
               }
        }
        if (fNoTabs)
        {
               if (!NoWorkInUTF())
               {
                ulIlen=NoTabs(cMain, ulMainSize, cMain, ulMainSize);
                ulMainSize=ulIlen;
               }
        }
        if (fNoSpaces)
        {
               if (!NoWorkInUTF())
               {
                ulIlen=NoSpaces(cMain, ulMainSize, cMain, ulMainSize);
                ulMainSize=ulIlen;
               }
        }
        if (fNoRus)
        {
               if (!NoWorkInUTF())
               {
                ulIlen=NoRus(cMain, ulMainSize, cMain, ulMainSize);
                ulMainSize=ulIlen;
               }
        }
        if (fNoSS)
        {
               if (!NoWorkInUTF())
               {
                ulIlen=NoSS(cMain, ulMainSize, cMain, ulMainSize);
                ulMainSize=ulIlen;
               }
        }
        if (fNoEnds)
        {
               if (!NoWorkInUTF())
               {

					ulIlen=NoEnds(cMain, ulMainSize, cMain, ulMainSize);
					ulMainSize=ulIlen;
               }
        }

        if (fTextMode)
        {
             if (!NoWorkInUTF())
             {
	               ulIlen=TextMode(cMain, ulMainSize, cMain, ulMainSize);
					ulMainSize=ulIlen;
             }
        }
        if (fDebug)
        {
             sprintf(szErrBuf,"codemapIN=%s\ncodemapOUT=%s\n", szInMap, szOutMap);
             sprintf(szErrBuf+strlen(szErrBuf), "infile=%s\n outfile=%s\n", szName, szDob);
             sprintf(szErrBuf+strlen(szErrBuf),"namep=%s\npath=%s\nsufix=%s\nto=%s\n", szNamep, szPath, szSufix, szTo);
             Report(szErrBuf);
        }


//-----Pack Xpk-----
        if (fPack)
        {

                if (XpkPackTags(XPK_InBuf, pIBuf, XPK_InLen, ulIBuflen,
                        XPK_PackMethod, szMyXPKMethod, XPK_GetOutBuf, &pOBuf,
                        XPK_GetOutBufLen, &ulOBuflen, XPK_GetOutLen, &ulOlen,
                        XPK_GetError, szErrBuf, TAG_DONE))
                {
                        strcat(szErrBuf, "\n");
                        Report(szErrBuf);
                        BeforeExit();
                        exit(RETURN_FAIL);
                }

                FreeMem(pIBuf, ulIBuflen);

                cMain=pIBuf=pOBuf;

                ulIBuflen=ulOBuflen;
                ulMainSize=ulIlen=ulOlen;

                pOBuf=NULL;
                ulOBuflen=ulOlen=0;

        }

        hOutFile=fopen(szDob, "w");
        if (!hOutFile)
        {
			strcpy(szErrBuf, GetString(MSG_NOOPEN_OUTFILE));
                sprintf(szErrBuf+strlen(szErrBuf), " - %s !\n", szDob);
                Report(szErrBuf);
                BeforeExit();
                exit(RETURN_FAIL);
        }
        fwrite((void*) cMain, ulMainSize, 1, hOutFile);

         if (hOutFile)
        {
                fclose(hOutFile);
                hOutFile=NULL;
        }

		SetMyComment();

//-----View text------
	if (fViewText)
	{
		sprintf(szCli, "%s \"%s\"", szViewer, szDob);
		if (system(szCli))
		{
			strcpy(szErrBuf, GetString(MSG_NORUN_VIEWTOOL));
			sprintf(szErrBuf+strlen(szErrBuf), " - %s !\n", szViewer);
			Report(szErrBuf);
		}
	}

	BeforeExit();

	return RETURN_OK;
}